import { html, repeat, when } from '@microsoft/fast-element';
import { buttonTag, iconTag, dropdownMenuTag, dividerTag } from '../tags';
/**
 * @public
 */
export const FoundationAlertsTemplate = html `
  <section class="wrapper">
    ${when((x) => x.displayState === 'add', html `
        <foundation-form
          resourceName="EVENT_DYNAMIC_RULE_NOTIFY_CREATE"
          design-system-prefix=${(x) => x.alertConfig.designSystemPrefix}
          @submit-success=${(x) => () => (x.displayState = 'list')}
        ></foundation-form>
      `)}
    ${when((x) => x.displayState === 'edit', html `
        <foundation-form
          resourceName="EVENT_DYNAMIC_RULE_NOTIFY_UPDATE"
          :data=${(x) => x.alertEditItemData}
          design-system-prefix=${(x) => x.alertConfig.designSystemPrefix}
          @submit-success=${(x) => (x.displayState = 'list')}
        ></foundation-form>
      `)}
    ${when((x) => x.displayState === 'list', html `
        <div class="header">
          <h2 class="title" part="title">Alerts rules</h2>
          <nav class="main-menu">
            <${buttonTag}
              class="main-button"
              @click=${(x) => x.handleAddAlertAction()}
              part="add-button"
            >
              <${iconTag} name="plus" size="1x"></${iconTag}>
            </${buttonTag}>
            <${dropdownMenuTag} 
              class="main-button filter-button"
              name=""
              :items=${(x) => x.filters}
              part="filter-button"
            />
              <${iconTag} name="filter" size="1x"></${iconTag}>
            </${dropdownMenuTag}>
          </nav>
        </div>
        ${when((x) => { var _a; return ((_a = x.items) === null || _a === void 0 ? void 0 : _a.length) >= 1; }, html `
            <ul class="list" part="list">
              ${repeat((x) => x.items, html `
                  <${dividerTag} class="item-separator"></${dividerTag}>
                  <li class="item" part="item">
                    <h4 class="item-title">${(x) => x.RULE_EXPRESSION}</h4>
                    <div class="item-bottom">
                      <span class="status ${(x) => x.RULE_STATUS.toLowerCase()}">
                        ${(x, c) => c.parent.statusLabelMap[x.RULE_STATUS]}
                      </span>
                      <span class="date">${(x) => x.DATE}</span>
                      <nav class="item-menu">
                        <${buttonTag}
                          class="button"
                          @click=${(x, c) => c.parent.handleEditAlertAction(x)}
                        >
                          <${iconTag} name="gear"></${iconTag}>
                        </${buttonTag}>
                        <${buttonTag} class="button" @click=${(x, c) => c.parent.toogleStatus(x)}>
                          <${iconTag} name="grip-lines-vertical"></${iconTag}>
                        </${buttonTag}>
                        <${buttonTag}
                          class="button"
                          @click=${(x, c) => c.parent.delete(x.DYNAMIC_NOTIFY_RULE_ID)}
                        >
                          <${iconTag} name="trash"></${iconTag}>
                        </${buttonTag}>
                      </nav>
                    </div>
                  </li>
                `)}
            </ul>
          `)}
        ${when((x) => { var _a; return ((_a = x.items) === null || _a === void 0 ? void 0 : _a.length) === 0; }, html `
            <p class="empty" part="empty">No alerts</p>
          `)}
      `)}
  </section>
`;
